
%define python_sitearch %(python -c "from distutils.sysconfig import get_python_lib; print get_python_lib(1)")
%define python64_sitearch %(python_64 -c "from distutils.sysconfig import get_python_lib; print get_python_lib(1)")

%define pyver %(python -c "import sys ; print sys.version[:3]")
%define py_incdir %{_includedir}/python%{pyver}

Summary:       Python's own image processing library
Name:          python-imaging
Version:       1.1.6
Release:       1
License:       MIT
Group:         System Environment/Libraries
Source0:       http://effbot.org/downloads/Imaging-%{version}.tar.gz
Patch2:        %{name}-giftrans.patch
Patch4:        %{name}-shebang.patch
# buffer overflow patch, bz 703212
Patch5:        %{name}-buffer.patch

URL:           http://www.pythonware.com/products/pil/
BuildRoot:     %{_tmppath}/%{name}-%{version}-%{release}-root

BuildRequires: patch

BuildRequires: freetype2-devel >= 2.3.12
BuildRequires: lcms-devel >= 1.19
BuildRequires: libjpeg-devel >= 6b-7
BuildRequires: python-devel >= 2.6.2
BuildRequires: tk-devel >= 8.5.8
BuildRequires: tkinter >= 2.6.2
BuildRequires: zlib-devel >= 1.2.3

Requires: freetype2 >= 2.3.12
Requires: lcms >= 1.19
Requires: libjpeg >= 6b-7
Requires: python >= 2.6.2
Requires: zlib >= 1.2.3

%description
Python Imaging Library

The Python Imaging Library (PIL) adds image processing capabilities
to your Python interpreter.

This library provides extensive file format support, an efficient
internal representation, and powerful image processing capabilities.

Notice that in order to reduce the package dependencies there are
three subpackages: devel (for development); tk (to interact with the
tk interface) and sane (scanning devices interface).


%package devel
Summary: Development files for python-imaging
Group: Development/Libraries
Requires: %{name} = %{version}-%{release}
Requires: freetype2-devel >= 2.3.12
Requires: lcms-devel >= 1.19
Requires: libjpeg-devel >= 6b-7
Requires: python-devel >= 2.6.2
Requires: tk-devel >= 8.5.8
Requires: zlib-devel >= 1.2.3

%description devel
Development files for python-imaging.


%package tk
Summary: Tk interface for python-imaging
Group: System Environment/Libraries
Requires: %{name} = %{version}-%{release}
Requires: tcl >= 8.5.8
Requires: tk >= 8.5.8
Requires: tkinter >= 2.6.2
Obsoletes: %{name} < %{version}-%{release}
Conflicts: %{name} < %{version}-%{release}

%description tk
This package contains a Tk interface for python-imaging.


%prep
%setup -q -n Imaging-%{version}
export PATH=/opt/freeware/bin:$PATH
%patch2 -p1
%patch4 -p1 -b .shebang
%patch5 -p1 -b .buffer

mkdir ../32bit
mv * ../32bit
mv ../32bit .
mkdir 64bit
cd 32bit && tar cf - . | (cd ../64bit ; tar xpf -)

# fix the interpreter path for Scripts/*.py
cd Scripts
for scr in *.py
do
  sed -e "s|/usr/local/bin/python|%{_bindir}/python|" ${scr} > tmp.py
  mv tmp.py ${scr}
  chmod 755 ${scr}
done
cd ../../64bit/Scripts
for scr in *.py
do
  sed -e "s|/usr/local/bin/python|%{_bindir}/python_64|" ${scr} > tmp.py
  mv tmp.py ${scr}
  chmod 755 ${scr}
done


%build
cd 64bit
# first build the 64-bit version
export OBJECT_MODE=64
CC=xlc_r python_64 setup.py build

cd ../32bit
# now build the 32-bit version
export OBJECT_MODE=32
CC=xlc_r python setup.py build


%install
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}

cd 64bit
python_64 setup.py install --skip-build --no-compile --root ${RPM_BUILD_ROOT}
cd ../32bit
python setup.py install --skip-build --no-compile --root ${RPM_BUILD_ROOT}

mkdir -p ${RPM_BUILD_ROOT}/%{py_incdir}/Imaging
cp libImaging/*.h ${RPM_BUILD_ROOT}/%{py_incdir}/Imaging
chmod 0644 ${RPM_BUILD_ROOT}/%{py_incdir}/Imaging/*.h

# There is no need to ship the binaries since they are already packaged
# in %doc
rm -rf ${RPM_BUILD_ROOT}%{_bindir}

# Separate files that need Tk and files that don't
echo '%%defattr (-,root,system,-)' > files.main
echo '%%defattr (-,root,system,-)' > files.tk
p="$PWD"

cd ${RPM_BUILD_ROOT}%{python_sitearch}/PIL
for file in *; do
    case "${file}" in
    ImageTk*|SpiderImagePlugin*|_imagingtk.so)
        what=files.tk
        ;;
    *)
        what=files.main
        ;;
    esac
    echo %{python_sitearch}/PIL/${file} >> "${p}/${what}"
done

cd ${RPM_BUILD_ROOT}%{python64_sitearch}/PIL
for file in *; do
    case "${file}" in
    ImageTk*|SpiderImagePlugin*|_imagingtk.so)
        what=files.tk
        ;;
    *)
        what=files.main
        ;;
    esac
    echo %{python64_sitearch}/PIL/${file} >> "${p}/${what}"
done


%clean
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}


%files -f 32bit/files.main
%defattr (-,root,system,-)
%doc 32bit/README 32bit/CHANGES
%{python_sitearch}/PIL.pth
%{python64_sitearch}/PIL.pth
%dir %{python_sitearch}/PIL
%dir %{python64_sitearch}/PIL


%files devel
%defattr (-,root,system,-)
%doc 32bit/Docs 32bit/Scripts 32bit/Images
%{py_incdir}/Imaging


%files tk -f 32bit/files.tk


%changelog
* Fri Nov 18 2011 Michael Perzl <michael@perzl.org> - 1.1.6-1
- first version for AIX V5.1 and higher
